package geoarbores.com.isa.jump.plugin;

import com.vividsolutions.jump.feature.AttributeType;
import com.vividsolutions.jump.feature.Feature;
import com.vividsolutions.jump.feature.FeatureCollectionWrapper;
import com.vividsolutions.jump.feature.FeatureSchema;
import com.vividsolutions.jump.workbench.JUMPWorkbench;
import com.vividsolutions.jump.workbench.WorkbenchContext;
import com.vividsolutions.jump.workbench.model.FeatureEventType;
import com.vividsolutions.jump.workbench.model.Layer;
import com.vividsolutions.jump.workbench.model.LayerManager;
import com.vividsolutions.jump.workbench.model.UndoableCommand;
import com.vividsolutions.jump.workbench.model.UndoableEditReceiver;
import com.vividsolutions.jump.workbench.plugin.AbstractPlugIn;
import com.vividsolutions.jump.workbench.plugin.EnableCheck;
import com.vividsolutions.jump.workbench.plugin.EnableCheckFactory;
import com.vividsolutions.jump.workbench.plugin.MultiEnableCheck;
import com.vividsolutions.jump.workbench.plugin.PlugInContext;
import com.vividsolutions.jump.workbench.ui.LayerViewPanel;
import com.vividsolutions.jump.workbench.ui.LayerViewPanelContext;
import com.vividsolutions.jump.workbench.ui.SelectionManager;
import com.vividsolutions.jump.workbench.ui.WorkbenchFrame;
import com.vividsolutions.jump.workbench.ui.WorkbenchToolBar;
import com.vividsolutions.jump.workbench.ui.images.IconLoader;
import com.vividsolutions.jump.workbench.ui.renderer.style.BasicStyle;
import org.openide.awt.DropDownButtonFactory;
import java.awt.Color;
import java.awt.Component;
import java.awt.Graphics;
import java.awt.GridLayout;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.Iterator;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JColorChooser;
import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;
 

public class FeatureColorChooserPlugIn extends AbstractPlugIn
{
  private int buttonWidth = 25;
  private PlugInContext context;
  private ComboButton colorChooserButton;
  private ComboButton colorSetbutton;
  private JPopupMenu colorPickerPopup = new JPopupMenu();
  private int customIndex = 1;
  //public static final String COLOR = "COLOR";

  
  
  
  public void initialize(final PlugInContext context)
    throws Exception
  {
    this.context = context;
	  //context.getWorkbenchContext().getWorkbench().getFrame().getToolBar().addPlugIn(getIcon(), this, createEnableCheck(context.getWorkbenchContext()), context.getWorkbenchContext());
    this.colorSetbutton = new ComboButton(1)
    {
      /**
		 * 
		 */
		private static final long serialVersionUID = 1L;

	public void setBounds(int x, int y, int width, int height) {
        super.setBounds(x, y, FeatureColorChooserPlugIn.this.buttonWidth, height);
      }
    };
    this.colorChooserButton = new ComboButton(0)
    {
      /**
		 * 
		 */
		private static final long serialVersionUID = 1L;

	public void setBounds(int x, int y, int width, int height) {
        super.setBounds(FeatureColorChooserPlugIn.this.colorSetbutton.getX() + FeatureColorChooserPlugIn.this.buttonWidth, y, FeatureColorChooserPlugIn.this.buttonWidth, height);
      }
    };
    this.colorSetbutton.addMouseListener(new MouseListener()
    {
      public void mouseClicked(MouseEvent e) {
        FeatureColorChooserPlugIn.this.setFeatureColor(FeatureColorChooserPlugIn.this.colorSetbutton.getColor());
      }

      public void mousePressed(MouseEvent e)
      {
      }

      public void mouseReleased(MouseEvent e)
      {
      }

      public void mouseExited(MouseEvent e)
      {
      }

      public void mouseEntered(MouseEvent e)
      {
      }
    });
    this.colorChooserButton.addMouseListener(new MouseListener()
    {
      public void mousePressed(MouseEvent e)
      {
        int x = FeatureColorChooserPlugIn.this.colorSetbutton.getLocation().x;
        int y = FeatureColorChooserPlugIn.this.colorSetbutton.getLocation().y + FeatureColorChooserPlugIn.this.colorSetbutton.getHeight();
        FeatureColorChooserPlugIn.this.colorPickerPopup.show(FeatureColorChooserPlugIn.this.colorSetbutton.getParent(), x, y);
      }

      public void mouseClicked(MouseEvent e)
      {
      }

      public void mouseReleased(MouseEvent e)
      {
      }

      public void mouseExited(MouseEvent e)
      {
      }

      public void mouseEntered(MouseEvent e)
      {
      }
    });
    
    
    JPopupMenu popup = new JPopupMenu();
    popup.setLayout(new GridLayout(0, 2));
    JMenuItem mi = new JMenuItem(I18NPlug.getI18N("com.isa.jump.plugin.FeatureColorChooserPlugIn.color-by-attribute"), new ColorIcon(null));
    mi.addActionListener(new ColorPickerActionListener(null));
    popup.add(mi);
    mi = new JMenuItem(I18NPlug.getI18N("com.isa.jump.plugin.FeatureColorChooserPlugIn.other-color"), 
    		getIcon());
      
        mi.addActionListener(new ActionListener()
    {
      public void actionPerformed(ActionEvent e) 
      {
        new JColorChooser(); Color color = JColorChooser.showDialog(context.getWorkbenchContext().getWorkbench().getFrame(), 
        I18NPlug.getI18N("com.isa.jump.plugin.FeatureColorChooserPlugIn.choose-new-color"), new Color(0, 0, 0));
        if (color != null)
        {
        	colorSetbutton.setColor(color);
        	setFeatureColor(color);
        	JMenuItem mi = new JMenuItem(I18NPlug.getI18N("com.isa.jump.plugin.FeatureColorChooserPlugIn.custom") 
        	+ customIndex, new ColorIcon(color));
        	mi.addActionListener(new ColorPickerActionListener(color));
        	colorPickerPopup.insert(mi, customIndex++);
        }
      }
    });
        popup.add(mi);  
    popup.add(mi);
    popup.addSeparator();
    popup.addSeparator();
    
    
    mi = new JMenuItem(I18NPlug.getI18N("com.isa.jump.plugin.FeatureColorChooserPlugIn.acad-0-black"), new ColorIcon(new Color(0, 0, 0)));
    mi.addActionListener(new ColorPickerActionListener(new Color(0, 0, 0)));
    popup.add(mi);
    mi = new JMenuItem(I18NPlug.getI18N("com.isa.jump.plugin.FeatureColorChooserPlugIn.acad-6-violet"), new ColorIcon(new Color(255, 0, 255)));
    mi.addActionListener(new ColorPickerActionListener(new Color(255, 0, 255)));
    popup.add(mi);
    mi = new JMenuItem(I18NPlug.getI18N("com.isa.jump.plugin.FeatureColorChooserPlugIn.acad-1-red"), new ColorIcon(new Color(255, 0, 0)));
    mi.addActionListener(new ColorPickerActionListener(new Color(255, 0, 0)));
    popup.add(mi);
    mi = new JMenuItem(I18NPlug.getI18N("com.isa.jump.plugin.FeatureColorChooserPlugIn.acad-7-white"), new ColorIcon(new Color(255, 255, 255)));
    mi.addActionListener(new ColorPickerActionListener(new Color(255, 255, 255)));
    popup.add(mi);
    mi = new JMenuItem(I18NPlug.getI18N("com.isa.jump.plugin.FeatureColorChooserPlugIn.acad-2-yellow"), new ColorIcon(new Color(255, 255, 0)));
    mi.addActionListener(new ColorPickerActionListener(new Color(255, 255, 0)));
    popup.add(mi);
    mi = new JMenuItem(I18NPlug.getI18N("com.isa.jump.plugin.FeatureColorChooserPlugIn.acad-8-gray"), new ColorIcon(new Color(65, 65, 65)));
    mi.addActionListener(new ColorPickerActionListener(new Color(65, 65, 65)));
    popup.add(mi);
    mi = new JMenuItem(I18NPlug.getI18N("com.isa.jump.plugin.FeatureColorChooserPlugIn.acad-3-green"), new ColorIcon(new Color(0, 255, 0)));
    mi.addActionListener(new ColorPickerActionListener(new Color(0, 255, 0)));
    popup.add(mi);
    mi = new JMenuItem(I18NPlug.getI18N("com.isa.jump.plugin.FeatureColorChooserPlugIn.acad-9-light-gray"), new ColorIcon(new Color(128, 128, 128)));
    mi.addActionListener(new ColorPickerActionListener(new Color(128, 128, 128)));
    popup.add(mi);
        popup.addSeparator();
    popup.addSeparator();
        
    mi = new JMenuItem(I18NPlug.getI18N("com.isa.jump.plugin.FeatureColorChooserPlugIn.cream"), new ColorIcon(new Color(255, 255, 204)));
    mi.addActionListener(new ColorPickerActionListener(new Color(255, 255, 204)));
    popup.add(mi);
    
    mi = new JMenuItem(I18NPlug.getI18N("com.isa.jump.plugin.FeatureColorChooserPlugIn.light-yellow"), new ColorIcon(new Color(255, 255, 102)));
    mi.addActionListener(new ColorPickerActionListener(new Color(255, 255, 102)));
    popup.add(mi);
    
    mi = new JMenuItem(I18NPlug.getI18N("com.isa.jump.plugin.FeatureColorChooserPlugIn.dark-orange"), new ColorIcon(new Color(255, 165, 0)));
    mi.addActionListener(new ColorPickerActionListener(new Color(255, 165, 0)));
    popup.add(mi);
    
    mi = new JMenuItem(I18NPlug.getI18N("com.isa.jump.plugin.FeatureColorChooserPlugIn.light-red"), new ColorIcon(new Color(255, 69, 0)));
    mi.addActionListener(new ColorPickerActionListener(new Color(255, 69, 0)));
    popup.add(mi);
    
    mi = new JMenuItem(I18NPlug.getI18N("com.isa.jump.plugin.FeatureColorChooserPlugIn.dark-red"), new ColorIcon(new Color(139, 0, 0)));
    mi.addActionListener(new ColorPickerActionListener(new Color(139, 0, 0)));
    popup.add(mi);
    
    mi = new JMenuItem(I18NPlug.getI18N("com.isa.jump.plugin.FeatureColorChooserPlugIn.magenta"), new ColorIcon(new Color(255, 0, 153)));
    mi.addActionListener(new ColorPickerActionListener(new Color(255, 0, 153)));
    popup.add(mi);
    
    mi = new JMenuItem(I18NPlug.getI18N("com.isa.jump.plugin.FeatureColorChooserPlugIn.maroon"), new ColorIcon(new Color(255, 0, 153)));
    mi.addActionListener(new ColorPickerActionListener(new Color(195, 33, 72)));
    popup.add(mi);
    mi = new JMenuItem(I18NPlug.getI18N("com.isa.jump.plugin.FeatureColorChooserPlugIn.pink"), new ColorIcon(new Color(255, 0, 153)));
    mi.addActionListener(new ColorPickerActionListener(new Color(255, 192, 203)));
    popup.add(mi);
    
    mi = new JMenuItem(I18NPlug.getI18N("com.isa.jump.plugin.FeatureColorChooserPlugIn.light-violet"), new ColorIcon(new Color(128, 0, 128)));
    mi.addActionListener(new ColorPickerActionListener(new Color(128, 0, 128)));
    popup.add(mi);
    
    mi = new JMenuItem(I18NPlug.getI18N("com.isa.jump.plugin.FeatureColorChooserPlugIn.turquoise"), new ColorIcon(new Color(175, 238, 238)));
    mi.addActionListener(new ColorPickerActionListener(new Color(175, 238, 238)));
    popup.add(mi);
    
    mi = new JMenuItem(I18NPlug.getI18N("com.isa.jump.plugin.FeatureColorChooserPlugIn.navy-blue"), new ColorIcon(new Color(0, 153, 153)));
    mi.addActionListener(new ColorPickerActionListener(new Color(0, 153, 153)));
    popup.add(mi);
    
    
    
    mi = new JMenuItem(I18NPlug.getI18N("com.isa.jump.plugin.FeatureColorChooserPlugIn.dark-blue"), new ColorIcon(new Color(0, 0, 153)));
    mi.addActionListener(new ColorPickerActionListener(new Color(0, 0, 153)));
    popup.add(mi);
    
    mi = new JMenuItem(I18NPlug.getI18N("com.isa.jump.plugin.FeatureColorChooserPlugIn.pale-green"), new ColorIcon(new Color(152, 251, 152)));
    mi.addActionListener(new ColorPickerActionListener(new Color(152, 251, 152)));
    popup.add(mi);
    
    
    
    
    mi = new JMenuItem(I18NPlug.getI18N("com.isa.jump.plugin.FeatureColorChooserPlugIn.light-green"), new ColorIcon(new Color(0, 187, 0)));
    mi.addActionListener(new ColorPickerActionListener(new Color(0, 187, 0)));
    popup.add(mi);
    mi = new JMenuItem(I18NPlug.getI18N("com.isa.jump.plugin.FeatureColorChooserPlugIn.olive-green"), new ColorIcon(new Color(85, 107, 47)));
    mi.addActionListener(new ColorPickerActionListener(new Color(85, 107, 47)));
    popup.add(mi);
    mi = new JMenuItem(I18NPlug.getI18N("com.isa.jump.plugin.FeatureColorChooserPlugIn.dark-green"), new ColorIcon(new Color(0, 100, 0)));
    mi.addActionListener(new ColorPickerActionListener(new Color(0, 100, 0)));
    popup.add(mi);
    mi = new JMenuItem(I18NPlug.getI18N("com.isa.jump.plugin.FeatureColorChooserPlugIn.light-brown"), new ColorIcon(new Color(210, 105, 30)));
    mi.addActionListener(new ColorPickerActionListener(new Color(210, 105, 30)));
    popup.add(mi);
    mi = new JMenuItem(I18NPlug.getI18N("com.isa.jump.plugin.FeatureColorChooserPlugIn.sand-brown"), new ColorIcon(new Color(244, 164, 96)));
    mi.addActionListener(new ColorPickerActionListener(new Color(244, 164, 96)));
    popup.add(mi);
    mi = new JMenuItem(I18NPlug.getI18N("com.isa.jump.plugin.FeatureColorChooserPlugIn.siena-brown"), new ColorIcon(new Color(160, 82, 45)));
    mi.addActionListener(new ColorPickerActionListener(new Color(160, 82, 45)));
    popup.add(mi);
    mi = new JMenuItem(I18NPlug.getI18N("com.isa.jump.plugin.FeatureColorChooserPlugIn.brown"), new ColorIcon(new Color(165, 42, 42)));
    mi.addActionListener(new ColorPickerActionListener(new Color(165, 42, 42)));
    popup.add(mi);
    mi = new JMenuItem(I18NPlug.getI18N("com.isa.jump.plugin.FeatureColorChooserPlugIn.dark-brown"), new ColorIcon(new Color(102, 51, 0)));
    mi.addActionListener(new ColorPickerActionListener(new Color(102, 51, 0)));
    popup.add(mi);
    mi = new JMenuItem(I18NPlug.getI18N("com.isa.jump.plugin.FeatureColorChooserPlugIn.dark-gray"), new ColorIcon(new Color(68, 68, 68)));
    mi.addActionListener(new ColorPickerActionListener(new Color(68, 68, 68)));
    popup.add(mi);
   // popup.addSeparator();
   
    this.colorPickerPopup = popup;
    this.colorSetbutton.setToolTipText(I18NPlug.getI18N("com.isa.jump.plugin.FeatureColorChooserPlugIn.set-color-Tool"));
    this.colorChooserButton.setToolTipText(I18NPlug.getI18N("com.isa.jump.plugin.FeatureColorChooserPlugIn.pick-color-tool"));
    context.getWorkbenchContext().getWorkbench().getFrame().getToolBar().addSeparator();
    context.getWorkbenchContext().getWorkbench().getFrame().getToolBar().add(this.colorSetbutton);
    context.getWorkbenchContext().getWorkbench().getFrame().getToolBar().add(this.colorChooserButton);
    context.getWorkbenchContext().getWorkbench().getFrame().getToolBar().addSeparator();
    
  }

  public Icon getIcon() {
      return new ImageIcon(getClass().getResource("color_wheel.png"));
  }
  
  
  private EnableCheck createEnableCheck(WorkbenchContext workbenchContext)
  {
    return null;
  }

  private void setFeatureColor(Color color)
  {
    LayerViewPanel layerViewPanel = this.context.getWorkbenchContext().getLayerViewPanel();
    if (layerViewPanel == null)
      return;
    Collection layers = layerViewPanel.getSelectionManager().getLayersWithSelectedItems();

    for (Iterator i = layers.iterator(); i.hasNext(); )
    {
      Layer layer = (Layer)i.next();
      if (layer.isEditable())
        continue;
      layerViewPanel.getContext().warnUser(I18NPlug.getI18N("com.isa.jump.plugin.FeatureColorChooserPlugIn.selected-items-layers-must-be-editable") + " (" + layer.getName() + ")");
      return;
    }

    for (Iterator i = layers.iterator(); i.hasNext(); )
    {
      Layer layer = (Layer)i.next();
      layer.setFeatureCollectionModified(true);
      FeatureCollectionWrapper fcw = layer.getFeatureCollectionWrapper();
      FeatureSchema schema = fcw.getFeatureSchema();

      if (schema.hasAttribute("R_G_B"))
        continue;
      schema.addAttribute("R_G_B", AttributeType.STRING);

      for (Iterator j = fcw.iterator(); j.hasNext(); )
      {
        Feature feature = (Feature)j.next();
        Object[] attributes = new Object[schema.getAttributeCount()];

        for (int k = 0; k < attributes.length - 1; k++) {
          attributes[k] = feature.getAttribute(k);
        }
        feature.setAttributes(attributes);
      }

    }

    Collection features = layerViewPanel.getSelectionManager().getFeaturesWithSelectedItems();
    setRGB(layers, features, getRGB(color));
  }

  public static FeatureSchema createFeatureSchema()
  {
    return new FeatureSchema()
    {

		/**
		 * 
		 */
		private static final long serialVersionUID = 1L;
    };
  }

  protected void setRGB(final Collection layers, final Collection features, String RGB)
  {
    if (layers.isEmpty())
      return;
    final String newRGB = RGB;
    final ArrayList RGBs = new ArrayList();

    for (Iterator f = features.iterator(); f.hasNext(); )
    {
      Feature feature = (Feature)f.next();
      RGBs.add(feature.getAttribute("R_G_B"));
    }

    final LayerManager layerManager = ((Layer)layers.iterator().next()).getLayerManager();
    layerManager.getUndoableEditReceiver().startReceiving();
    
    try {
        UndoableCommand command =
            new UndoableCommand("Edit R_G_B") {
            public void execute() {
                for (Iterator f = features.iterator(); f.hasNext();)
                {
                	 Feature feature = (Feature) f.next();
                	 feature.setAttribute(BasicStyle.RGB_ATTRIBUTE_NAME, newRGB);
                }
            	
                for (Iterator i = layers.iterator(); i.hasNext();)
                {
                		Layer layer = (Layer) i.next();
                		layer.fireAppearanceChanged();
                        layerManager.fireFeaturesChanged(
                		        Arrays.asList(features.toArray()),
                		        FeatureEventType.ATTRIBUTES_MODIFIED,
                		        layer);
                }

            }
            public void unexecute() {
            	int i = 0;
                for (Iterator f = features.iterator(); f.hasNext();)
                {
                	 Feature feature = (Feature) f.next();
                	 feature.setAttribute(BasicStyle.RGB_ATTRIBUTE_NAME, RGBs.get(i++));
                }
            	
                for (Iterator j = layers.iterator(); j.hasNext();)
                {
                		Layer layer = (Layer) j.next();
                		layer.fireAppearanceChanged();
                        layerManager.fireFeaturesChanged(
                		        Arrays.asList(features.toArray()),
                		        FeatureEventType.ATTRIBUTES_MODIFIED,
                		        layer);
                }
            }
        };
        command.execute();
        layerManager.getUndoableEditReceiver().receive(
            command.toUndoableEdit());
    } finally {
    	layerManager.getUndoableEditReceiver().stopReceiving();
    }

  }

  private String getRGB(Color color)
  {
    if (color == null)
    {
      return "";
    }

    int r = color.getRed();
    int g = color.getGreen();
    int b = color.getBlue();
    String rHex = Integer.toHexString(r).toUpperCase();
    String gHex = Integer.toHexString(g).toUpperCase();
    String bHex = Integer.toHexString(b).toUpperCase();

    if (rHex.length() < 2) rHex = "0" + rHex;
    if (gHex.length() < 2) gHex = "0" + gHex;
    if (bHex.length() < 2) bHex = "0" + bHex;

    return rHex + gHex + bHex;
  }

  public boolean execute(PlugInContext context)
    throws Exception
  {
    return true;
  }

 

  public static EnableCheck createEnableCheck(WorkbenchContext workbenchContext, boolean b)
  {
    EnableCheckFactory checkFactory = new EnableCheckFactory(workbenchContext);

    return new MultiEnableCheck().add(checkFactory.createWindowWithLayerViewPanelMustBeActiveCheck())
      .add(checkFactory.createAtLeastNLayersMustBeEditableCheck(1));
  }

  private class ColorIcon
    implements Icon
  {
    private Color color = null;

    public ColorIcon(Color color)
    {
      this.color = color;
    }

    public int getIconHeight()
    {
      return 10;
    }

    public int getIconWidth()
    {
      return 10;
    }

    public void paintIcon(Component comp, Graphics g, int x, int y)
    {
      Color oldColor = g.getColor();

      int j = 0;
      int size = Math.max(getIconHeight(), 2);
      g.translate(x, y);

      if (this.color == null)
        g.setColor(new Color(0, 0, 0));
      else {
        g.setColor(this.color);
      }
      j = 0;

      if (this.color == null)
      {
        g.drawLine(0, 8, 5, 8);
        g.drawLine(5, 8, 5, 7);
        g.drawLine(1, 8, 1, 1);
        g.drawLine(0, 1, 2, 1);
      }
      else
      {
        for (int i = size - 1; i >= 0; i--)
        {
          g.drawLine(0, j, 7, j);
          j++;
        }
      }
      g.translate(-x, -y);
      g.setColor(oldColor);
    }
  }

  private class ColorPickerActionListener implements ActionListener
  {
    Color color = null;

    ColorPickerActionListener(Color color)
    {
      this.color = color;
    }

    public void actionPerformed(ActionEvent e)
    {
      FeatureColorChooserPlugIn.this.colorSetbutton.setColor(this.color);
      FeatureColorChooserPlugIn.this.setFeatureColor(this.color);
    }
  }
}